|  | Home · All Classes · All Functions · Overviews

# QRunnable Class Reference
[QtCore module]

The QRunnable class is the base class for all runnable objects. More...

     #include <QRunnable>

This class was introduced in Qt 4.4.

- List of all members, including inherited members

## Public Functions

| QRunnable ()
virtual | ~QRunnable ()
bool | autoDelete () const
virtual void | run () = 0
void | setAutoDelete ( bool autoDelete )

## Detailed Description

The QRunnable class is the base class for all runnable objects.

The QRunnable class is an interface for representing a task or piece of code that needs to be executed, represented by your reimplementation of the run() function.

You can use QThreadPool to execute your code in a separate thread. QThreadPool deletes the QRunnable automatically if autoDelete() returns true (the default). Use setAutoDelete() to change the auto-deletion flag.

QThreadPool supports executing the same QRunnable more than once by calling QThreadPool::tryStart(this) from within the run() function. If autoDelete is enabled the QRunnable will be deleted when the last thread exits the run function. Calling QThreadPool::start() multiple times with the same QRunnable when autoDelete is enabled creates a race condition and is not recommended.

See also QThreadPool.

## Member Function Documentation

### QRunnable::QRunnable ()

Constructs a QRunnable. Auto-deletion is enabled by default.

See also autoDelete() and setAutoDelete().

### QRunnable::~QRunnable () `[virtual]`

QRunnable virtual destructor.

### bool QRunnable::autoDelete () const

Returns true is auto-deletion is enabled; false otherwise.

If auto-deletion is enabled, QThreadPool will automatically delete this runnable after calling run(); otherwise, ownership remains with the application programmer.

See also setAutoDelete() and QThreadPool.

### void QRunnable::run () `[pure virtual]`

Implement this pure virtual function in your subclass.

### void QRunnable::setAutoDelete ( bool autoDelete )

Enables auto-deletion if autoDelete is true; otherwise auto-deletion is disabled.

If auto-deletion is enabled, QThreadPool will automatically delete this runnable after calling run(); otherwise, ownership remains with the application programmer.

Note that this flag must be set before calling QThreadPool::start(). Calling this function after QThreadPool::start() results in undefined behavior.

See also autoDelete() and QThreadPool.